Index: src/sans/models/media/model_functions.rst
===================================================================
--- src/sans/models/media/model_functions.rst	(revision 4ed2d0a1586325fec013f8b1591ff80c5f47cd48)
+++ src/sans/models/media/model_functions.rst	(revision 58eccf65f2d6cb3ae93074ffa155eaa939bb67da)
@@ -1,3 +1,5 @@
 .. model_functions.rst
+
+.. NB: This document does not have M Gonzalez's model descriptions in it.
 
 .. This is a port of the original SasView model_functions.html to ReSTructured text
@@ -32,11 +34,8 @@
 .. |psi| unicode:: U+03C8
 .. |omega| unicode:: U+03C9
-
 .. |bigdelta| unicode:: U+0394
 .. |biggamma| unicode:: U+0393
 .. |bigpsi| unicode:: U+03A8
-
 .. |drho| replace:: |bigdelta|\ |rho|
-
 .. |Ang| unicode:: U+212B
 .. |Ang^-1| replace:: |Ang|\ :sup:`-1`
@@ -44,4 +43,6 @@
 .. |Ang^-2| replace:: |Ang|\ :sup:`-2`
 .. |Ang^3| replace:: |Ang|\ :sup:`3`
+.. |Ang^-3| replace:: |Ang|\ :sup:`-3`
+.. |Ang^-4| replace:: |Ang|\ :sup:`-4`
 .. |cm^-1| replace:: cm\ :sup:`-1`
 .. |cm^2| replace:: cm\ :sup:`2`
@@ -50,5 +51,4 @@
 .. |cm^-3| replace:: cm\ :sup:`-3`
 .. |sr^-1| replace:: sr\ :sup:`-1`
-
 .. |P0| replace:: P\ :sub:`0`\
 .. |A2| replace:: A\ :sub:`2`\
@@ -1217,5 +1217,5 @@
 
 and |alpha| is the angle between the axis of the cylinder and the *q*-vector, *V* is the volume of the cylinder,
-*L* is the length of the cylinder, *r* is the radius of the cylinder, and |bigdelta|\ |rho| (contrast) is the
+*L* is the length of the cylinder, *r* is the radius of the cylinder, and |drho| (contrast) is the
 scattering length density difference between the scatterer and the solvent. *J1* is the first order Bessel function.
 
@@ -2074,5 +2074,5 @@
 |alpha| is the angle between the axis of the ellipsoid and the *q*\ -vector, *V* is the volume of the ellipsoid, *Ra*
 is the radius along the rotational axis of the ellipsoid, *Rb* is the radius perpendicular to the rotational axis of
-the ellipsoid and |bigdelta|\ |rho| (contrast) is the scattering length density difference between the scatterer and
+the ellipsoid and |drho| (contrast) is the scattering length density difference between the scatterer and
 the solvent.
 
@@ -2421,5 +2421,5 @@
 
 where |delta|\ T = tail length (or *t_length*), |delta|\ H = head thickness (or *h_thickness*),
-|bigdelta|\ |rho|\ H = SLD(headgroup) - SLD(solvent), and |bigdelta|\ |rho|\ T = SLD(tail) - SLD(solvent).
+|drho|\ H = SLD(headgroup) - SLD(solvent), and |drho|\ T = SLD(tail) - SLD(solvent).
 
 The 2D scattering intensity is calculated in the same way as 1D, where the *q* vector is defined as
@@ -2484,5 +2484,5 @@
 .. image:: img/image141.PNG
 
-Here *d* = (repeat) spacing, |delta| = bilayer thickness, the contrast |bigdelta|\ |rho| = SLD(headgroup) - SLD(solvent),
+Here *d* = (repeat) spacing, |delta| = bilayer thickness, the contrast |drho| = SLD(headgroup) - SLD(solvent),
 K = smectic bending elasticity, B = compression modulus, and N = number of lamellar plates (*n_plates*).
 
@@ -2551,5 +2551,5 @@
 
 where |delta|\ T = tail length (or *t_length*), |delta|\ H = head thickness (or *h_thickness*),
-|bigdelta|\ |rho|\ H = SLD(headgroup) - SLD(solvent), and |bigdelta|\ |rho|\ T = SLD(tail) - SLD(headgroup).
+|drho|\ H = SLD(headgroup) - SLD(solvent), and |drho|\ T = SLD(tail) - SLD(headgroup).
 Here *d* = (repeat) spacing, *K* = smectic bending elasticity, *B* = compression modulus, and N = number of lamellar
 plates (*n_plates*).
@@ -3124,5 +3124,5 @@
 .. _Debye:
 
-**2.2.1. Debye (Model)**
+**2.2.1. Debye (Gaussian Coil Model)**
 
 The Debye model is a form factor for a linear polymer chain. In addition
@@ -3138,11 +3138,8 @@
 ==============  ========  =============
 Parameter name  Units     Default value
-
-==============  ========  =============
-| scale None 1.0 
-
-| rg   ÃâŠ    50.0
-
-| background              | cm-1 0.0 
+==============  ========  =============
+scale           None      1.0
+rg              |Ang|     50.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3160,5 +3157,5 @@
 .. _BroadPeakModel:
 
-**2.2.2. BroadPeak Model**
+**2.2.2. BroadPeakModel**
 
 Calculate an empirical functional form for SANS data characterized by a
@@ -3183,21 +3180,15 @@
 .. image:: img/image040.GIF
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| scale\_l (= C)          | Â     10  
-
-| scale\_p (=A)           | Â     1e-05
-
-| length\_l (=x)          | ÃâŠ    50  
-
-| q\_peak (= Q0)          | ÃâŠ-1  0.1 
-
-| exponent\_p (=n)        | Â     2   
-
-| exponent\_l (=m)        | Â     3   
-
-| Background (=B)         | cm-1 0.1 
-==============  ========  =============
+===============  ========  =============
+Parameter name   Units     Default value
+===============  ========  =============
+scale_l    (=C)  None      10
+scale_p    (=A)  None      1e-05
+length_l   (=x)  |Ang|     50
+q_peak    (=Q0)  |Ang^-1|  0.1
+exponent_p (=n)  None      2
+exponent_l (=m)  None      3
+Background (=B)  |cm^-1|   0.1
+===============  ========  =============
 
 .. image:: img/image175.JPG
@@ -3215,5 +3206,5 @@
 .. _CorrLength:
 
-**2.2.3. CorrLength (CorrelationLengthModel)**
+**2.2.3. CorrLength (Correlation Length Model)**
 
 Calculate an empirical functional form for SANS data characterized by a
@@ -3239,19 +3230,14 @@
 .. image:: img/image040.GIF
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| scale\_l (= C)          | Â     10  
-
-| scale\_p (=A)           | Â     1e-06
-
-| length\_l (=x)          | ÃâŠ    50  
-
-| exponent\_p (=n)        | Â     2   
-
-| exponent\_l (=m)        | Â     3   
-
-| Background (=B)         | cm-1 0.1 
-==============  ========  =============
+===============  ========  =============
+Parameter name   Units     Default value
+===============  ========  =============
+scale_l    (=C)  None Â     10
+scale_p    (=A)  None Â     1e-06
+length_l   (=x)  |Ang|     50
+exponent_p (=n)  None Â     2
+exponent_l (=m)  NoneÂ      3
+Background (=B)  |cm^-1|   0.1
+===============  ========  =============
 
 .. image:: img/image177.JPG
@@ -3270,5 +3256,5 @@
 .. _Lorentz:
 
-**2.2.4. (Ornstein-Zernicke) Lorentz (Model)**
+**2.2.4. Lorentz (Ornstein-Zernicke Model)**
 
 The Ornstein-Zernicke model is defined by:
@@ -3285,9 +3271,7 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale None 1.0 
-
-| length ÃâŠ    50.0
-
-| background              | cm-1 0.0 
+scale           None      1.0
+length          |Ang|     50.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3300,5 +3284,5 @@
 .. _DABModel:
 
-**2.2.5. DAB (Debye-Anderson-Brumberger) Model**
+**2.2.5. DABModel (Debye-Anderson-Brumberger Model)**
 
 Calculates the scattering from a randomly distributed, two-phase system
@@ -3321,9 +3305,7 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale None 1.0 
-
-| length ÃâŠ    50.0
-
-| background              | cm-1 0.0 
+scale           None      1.0
+length          |Ang|     50.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3347,5 +3329,5 @@
 .. _AbsolutePower_Law:
 
-**2.2.6.  Absolute Power\_Law**
+**2.2.6. AbsolutePower_Law**
 
 This model describes a power law with background.
@@ -3358,9 +3340,7 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| Scale None 1.0 
-
-| m    None 4   
-
-| Background              | cm-1 0.0 
+Scale           None      1.0
+m               None      4
+Background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3387,11 +3367,8 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale None 0.1 
-
-| c1   None -30.0
-
-| c2   None 5000.0
-
-| background              | cm-1 0.0 
+scale           None      0.1
+c1              None      -30.0
+c2              None      5000.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3411,5 +3388,5 @@
 .. _FractalModel:
 
-**2.2.8.  FractalModel**
+**2.2.8. FractalModel**
 
 Calculates the scattering from fractal-like aggregates built from
@@ -3434,17 +3411,11 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale None 0.05
-
-| radius ÃâŠ    5.0 
-
-| fractal\_dim            | None 2   
-
-| corr\_length            | ÃâŠ    100.0
-
-| block\_sld              | ÃâŠ-2  2e-6
-
-| solvent\_sld            | ÃâŠ-2  6e-6
-
-| background              | cm-1 0.0 
+scale           None      0.05
+radius          |Ang|     5.0
+fractal_dim     None      2
+corr_length     |Ang|     100.0
+block_sld       |Ang^-2|  2e-6
+solvent_sld     |Ang^-2|  6e-6
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3473,18 +3444,14 @@
 scattering length density of particles.
 
-Note: Â The mass fractal dimension is valid for 1<mass\_dim<6.
-
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| scale None 1   
-
-| radius ÃâŠ    10.0
-
-| mass\_dim               | None 1.9 
-
-| co\_length              | ÃâŠ    100.0
-
-| background              | Â     0.0 
+Note: Â The mass fractal dimension is valid for 1<mass_dim<6.
+
+==============  ========  =============
+Parameter name  Units     Default value
+==============  ========  =============
+scale           None      1
+radius          |Ang|     10.0
+mass_dim        None      1.9
+co_length       |Ang|     100.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3515,5 +3482,5 @@
 scattering length density of particles.
 
-Â Note: Â The surface fractal dimension is valid for 1<surface\_dim<3.
+Â Note: Â The surface fractal dimension is valid for 1<surface_dim<3.
 Â Also it is valid in a limited q range (see the reference for details).
 
@@ -3521,13 +3488,9 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale None 1   
-
-| radius ÃâŠ    10.0
-
-| surface\_dim            | None 2.0 
-
-| co\_length              | ÃâŠ    500.0
-
-| background              | Â     0.0 
+scale           None      1
+radius          |Ang|     10.0
+surface_dim     None      2.0
+co_length       |Ang|     500.0
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3545,5 +3508,5 @@
 .. _MassSurfaceFractal:
 
-**2.2.11. MassSurfaceFractal**
+**2.2.11. MassSurfaceFractal (Model)**
 
 A number of natural and commercial processes form high-surface area
@@ -3572,20 +3535,15 @@
 
 Â Note: Â The surface and mass fractal dimensions are valid for
-0<surface\_dim<6, 0<mass\_dim<6, and (surface\_mass+mass\_dim)<6.Â 
-
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| scale None 1   
-
-| primary\_rg             | ÃâŠ    4000.0
-
-| Â  cluster\_rg           | Â  ÃâŠ  Â 86.7
-
-| surface\_dim            | None 2.3 
-
-| Â  mass\_dim             | Â None Â 1.8
-
-| background              | Â     0.0 
+0<surface_dim<6, 0<mass_dim<6, and (surface_mass+mass_dim)<6.Â 
+
+==============  ========  =============
+Parameter name  Units     Default value
+==============  ========  =============
+scale           None      1
+primary_rg      |Ang|     4000.0
+cluster_rg      |Ang|  Â   86.7
+surface_dim     None      2.3
+mass_dim        None Â     1.8
+background      |cm^-1| Â  0.0
 ==============  ========  =============
 
@@ -3604,5 +3562,5 @@
 .. _FractalCoreShell:
 
-**2.2.12.  FractalCoreShell(Model)**
+**2.2.12. FractalCoreShell (Model)**
 
 Calculates the scattering from a fractal structure with a primary
@@ -3620,5 +3578,5 @@
 .. image:: img/fractcore_eq3.gif
 
-where Df = frac\_dim, ÃÂŸ = cor\_length, rc = (core) radius, and scale
+where Df = frac_dim, ÃÂŸ = cor_length, rc = (core) radius, and scale
 = volfraction.
 
@@ -3639,21 +3597,13 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| volfraction             | Â     0.05
-
-| frac\_dim               | Â     2   
-
-| thickness               | ÃâŠ    5.0 
-
-| raidus Â ÃâŠ   20.0
-
-| cor\_length             | ÃâŠ    100.0
-
-| core\_sld               | ÃâŠ-2  3.5e-6
-
-| shell\_sld              | ÃâŠ-2  1e-6
-
-| solvent\_sld            | ÃâŠ-2  6.35e-6
-
-| background              | cm-1 0.0 
+volfraction     None Â     0.05
+frac_dim        None Â     2
+thickness       |Ang|     5.0
+radius Â         |Ang|     20.0
+cor_length      |Ang|     100.0
+core_sld        |Ang^-2|  3.5e-6
+shell_sld       |Ang^-2|  1e-6
+solvent_sld     |Ang^-2|  6.35e-6
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -3670,5 +3620,5 @@
 .. _GaussLorentzGel:
 
-**2.2.13.  GaussLorentzGel(Model)**
+**2.2.13. GaussLorentzGel(Model)**
 
 Calculates the scattering from a gel structure, typically a physical
@@ -3699,21 +3649,13 @@
 .. image:: img/image040.GIF
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| dyn\_colength(=Dynamic  | ÃâŠ    20.0
-| correlation length)     |          
-
-| scale\_g(=Gauss scale   | Â     100 
-| factor)          
-
-| scale\_l(=Lorentzian    | Â     50  
-| scale factor)           |          
-
-| stat\_colength(=Static  | ÃâŠ    100.0
-| correlation Z)          |          
-
-| background              | cm-1 0.0 
-==============  ========  =============
+===================================  ========  =============
+Parameter name                       Units     Default value
+===================================  ========  =============
+dyn_colength (=dynamic corr length)  |Ang|     20.0
+scale_g       (=Gauss scale factor)  None Â     100
+scale_l  (=Lorentzian scale factor)  NoneÂ      50
+stat_colength (=static corr length)  |Ang|     100.0
+background                           |cm^-1|   0.0
+===================================  ========  =============
 
 .. image:: img/image190.JPG
@@ -3730,5 +3672,5 @@
 .. _BEPolyelectrolyte:
 
-**2.2.14.  BEPolyelectrolyte Model**
+**2.2.14. BEPolyelectrolyte (Model)**
 
 Calculates the structure factor of a polyelectrolyte solution with the
@@ -3750,20 +3692,15 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| K    Barns = 10-24 cm2       | 10  
-
-| Lb   ÃâŠ    7.1 
-
-| h    ÃâŠ-3  12  
-
-| b    ÃâŠ    10  
-
-| Cs   Mol/L 0   
-
-| alpha None 0.05
-
-| Ca   Mol/L 0.7 
-
-| background              | cm-1 0.0 
-==============  ========  =============
+K               barns     10
+Lb              |Ang|     7.1
+h               |Ang^-3|  12
+b               |Ang|     10
+Cs              mol/L     0
+alpha           None      0.05
+Ca              mol/L     0.7
+background      |cm^-1|   0.0
+==============  ========  =============
+
+NB: 1 barn = 10\ :sup:`-24` |cm^2|
 
 REFERENCE
@@ -3797,7 +3734,6 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale cm-1 1.0 
-
-| Rg   ÃâŠ    0.1 
+scale           |cm^-1|   1.0
+Rg              |Ang|     0.1
 ==============  ========  =============
 
@@ -3863,19 +3799,13 @@
 .. image:: img/image008.PNG
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| Scale(=Guinier scale,   | cm-1 1.0 
-| G)            
-
-| rg   ÃâŠ    100 
-
-| dim(=Dimensional        | Â     1   
-| Variable, s)            |          
-
-| m(=Porod exponent)      | Â     3   
-
-| background              | Â     0.1 
-==============  ========  =============
+==============================  ========  =============
+Parameter name                  Units     Default value
+==============================  ========  =============
+scale      (=Guinier scale, G)  |cm^-1|   1.0
+rg                              |Ang|     100
+dim (=dimensional variable, s)  None Â     1
+m            (=Porod exponent)  None Â     3
+background                      |cm^-1|Â   0.1
+==============================  ========  =============
 
 .. image:: img/image196.JPG
@@ -3907,7 +3837,6 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale ÃâŠ-4  0.1 
-
-| background              | cm-1 0   
+scale           |Ang^-4|  0.1
+background      |cm^-1|   0
 ==============  ========  =============
 
@@ -3925,5 +3854,5 @@
 deviation of B.Â  The fwhm is 2.354\*B.Â Â 
 
-Parameters I0, B, qpk, and BGD can all be adjusted during fitting.
+Parameters I0, B, qpk, and BGD can all be adjusted during fitting. **NB: These don't match the table!**
 
 REFERENCE
@@ -3938,11 +3867,8 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale cm-1 100 
-
-| q0   ÃâŠ    0.05
-
-| B    Â     0.005
-
-| background              | Â     1   
+scale           |cm^-1|   100
+q0              |Ang^-1|  0.05
+B    Â           |Ang^-1|  0.005
+background      |cm^-1|Â   1
 ==============  ========  =============
 
@@ -3964,5 +3890,5 @@
 (half-width-half-maximum) of B.Â 
 
-The parameters I0, B, qpk, and BGD can all be adjusted during fitting.
+The parameters I0, B, qpk, and BGD can all be adjusted during fitting. **NB: These don't match the table!**
 
 REFERENCE
@@ -3977,11 +3903,8 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale cm-1 100 
-
-| q0   ÃâŠ    0.05
-
-| B    Â     0.005
-
-| background              | Â     1   
+scale           |cm^-1|   100
+q0              |Ang^-1|  0.05
+B    Â           |Ang^-1|  0.005
+background      |cm^-1|Â     1
 ==============  ========  =============
 
@@ -4023,18 +3946,14 @@
 TEST DATASET
 
-Â This example dataset is produced by running the Poly\_GaussCoil, using
-200 data points, qmin = 0.001 ÃâŠ-1,Â  qmax = 0.7 ÃâŠ-1Â Â  and the default
-values below.
-
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| Scale None 1.0 
-
-| rg   ÃâŠ    60.0
-
-| poly\_m Mw/Mn 2   
-
-| background              | cm-1 0.001
+This example dataset is produced by running the Poly_GaussCoil, using 200 data points, *qmin* = 0.001 |Ang^-1|\ ,
+qmax = 0.7 |Ang^-1|Â and the default values below.
+
+==============  ========  =============
+Parameter name  Units     Default value
+==============  ========  =============
+scale           None      1.0
+rg              |Ang|     60.0
+poly_m (Mw/Mn)  None      2
+background      |cm^-1|   0.001
 ==============  ========  =============
 
@@ -4130,18 +4049,15 @@
 TEST DATASET
 
-Â This example dataset is produced, using 200 data points, qmin = 0.001
-ÃâŠ-1,Â  qmax = 0.2 ÃâŠ-1Â Â  and the default values below.
-
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| Scale None 1.0 
-
-| rg   ÃâŠ    60.0
-
-| m(=Porod exponent)      | Â     3   
-
-| background              | cm-1 0.0 
-==============  ========  =============
+This example dataset is produced, using 200 data points, qmin = 0.001 |Ang^-1|\ ,Â  qmax = 0.2 |Ang^-1|Â Â and the
+default values below.
+
+===================  ========  =============
+Parameter name       Units     Default value
+===================  ========  =============
+scale                None      1.0
+rg                   |Ang|     60.0
+m (=Porod exponent)  None Â     3
+background           |cm^-1|   0.0
+===================  ========  =============
 
 .. image:: img/image214.JPG
@@ -4210,43 +4126,28 @@
 Fitting parameters for Case0 Model
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| background              | cm-1 0.0 
-
-| scale Â     1   
-
-| bc(=Seg. Length bc)     | Â     5   
-
-| bd(=Seg. Length bd)     | Â     5   
-
-| Kcd(Chi Param. Kcd)     | Â     -0.0004
-==============  ========  =============
+=======================  ========  =============
+Parameter name           Units     Default value
+=======================  ========  =============
+background               |cm^-1|   0.0
+scale Â                   None      1
+bc (=segment Length_bc)  **unit**  5
+bd (=segment length_bd)  **unit**  5
+Kcd (=chi_cd)            **unit**  -0.0004
+=======================  ========  =============
 
 Fixed parameters for Case0 Model
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| Lc(= Scatter.           | Â     1e-12
-| Length\_c)              |          
-
-| Ld(= Scatter.           | Â     0   
-| Length\_d)              |          
-
-| Nc(=Deg.Polym.c)        | Â     1000
-
-| Nd(=Deg.Polym.d)        | Â     1000
-
-| Phic(=Vol. fraction of  | Â     0.25
-| c)            
-
-| Phid(=Vol. fraction of  | Â     0.25
-| d)            
-
-| vc(=Spec. vol. of c)    | Â     100 
-
-| vd(=Spec. vol. of d)    | Â     100 
-==============  ========  =============
+=======================  ========  =============
+Parameter name           Units     Default value
+=======================  ========  =============
+Lc (=scatter. length_c)  **unit**  1e-12
+Ld (=scatter. length_d)  **unit**  0
+Nc    (=degree polym_c)  None      1000
+Nd    (=degree polym_d)  None Â     1000
+Phic (=vol. fraction_c)  None Â     0.25
+Phid (=vol. fraction_d)  None Â     0.25
+vc (=specific volume_c)  **unit**  100
+vd (=specific volume_d)  **unit**  100
+=======================  ========  =============
 
 .. image:: img/image215.JPG
@@ -4259,5 +4160,5 @@
 .. _TwoLorentzian:
 
-**2.2.23. TwoLorentzian(Model)**
+**2.2.23. TwoLorentzian (Model)**
 
 Calculate an empirical functional form for SANS data characterized by a
@@ -4285,23 +4186,15 @@
 **Default input parameter values**
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| scale\_1(=A)            | Â     10  
-
-| scale\_2(=C)            | Â     1   
-
-| 1ength\_1 (=Correlation | ÃâŠ    100 
-| length1)                |          
-
-| 1ength\_2(=Correlation  | ÃâŠ    10  
-| length2)                |          
-
-| exponent\_1(=n)         | Â     3   
-
-| exponent\_2(=m)         | Â     2   
-
-| Background(=B)          | cm-1 0.1 
-==============  ========  =============
+===============================  ========  =============
+Parameter name                   Units     Default value
+===============================  ========  =============
+scale_1 (=A)                     None Â     10
+scale_2 (=C)                     None Â     1
+1ength_1 (=correlation length1)  |Ang|     100
+1ength_2 (=correlation length2)  |Ang|     10
+exponent_1 (=n)                  None Â     3
+exponent_2 (=m)                  None Â     2
+background (=B)                  |cm^-1|   0.1
+===============================  ========  =============
 
 .. image:: img/image217.JPG
@@ -4317,5 +4210,5 @@
 .. _TwoPowerLaw:
 
-**2.2.24. TwoPowerLaw(Model)**
+**2.2.24. TwoPowerLaw (Model)**
 
 Calculate an empirical functional form for SANS data characterized by
@@ -4342,13 +4235,9 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| coef\_A Â     1.0 
-
-| qc   ÃâŠ-1  0.04
-
-| power\_1(=m1)           | Â     4   
-
-| power\_2(=m2)           | Â     4   
-
-| background              | cm-1 0.0 
+coef_A Â         None      1.0
+qc              |Ang^-1|  0.04
+power_1 (=m1)   None Â     4
+power_2 (=m2)   None Â     4
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -4361,5 +4250,5 @@
 .. _UnifiedPowerRg:
 
-**2.2.25. UnifiedPower(Law and)Rg(Model)**
+**2.2.25. UnifiedPowerRg (Beaucage Model)**
 
 The returned value is scaled to units of |cm^-1|, absolute scale.Â 
@@ -4397,23 +4286,14 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| scale Â     1.0 
-
-| Rg2  ÃâŠ    21  
-
-| power2 Â     2   
-
-| G2   cm-1sr-1                | 3   
-
-| B2   cm-1sr-1                | 0.0006
-
-| Rg1  ÃâŠ    15.8
-
-| power1 Â     4   
-
-| G1   cm-1sr-1                | 400 
-
-| B1   cm-1sr-1                | 4.5e-006                |
-
-| background              | cm-1 0.0 
+scale Â          None      1.0
+Rg2             |Ang|     21
+power2 Â         None      2
+G2              |cm^-1|   3
+B2              |cm^-1|   0.0006
+Rg1             |Ang|     15.8
+power1 Â         None      4
+G1              |cm^-1|   400
+B1              |cm^-1|   4.5e-6                |
+background      |cm^-1|   0.0
 ==============  ========  =============
 
@@ -4440,5 +4320,5 @@
 where A and B are the coefficients of the first and second order terms.
 
-**Note:** For 2D plot, *I(q)*= I(qx)\*I(qy)Â  which is defined differently
+**Note:** For 2D plot, *I(q)* = *I(qx)* / *I(qy)*Â  which is defined differently
 from other shape independent models.
 
@@ -4446,7 +4326,6 @@
 Parameter name  Units     Default value
 ==============  ========  =============
-| A    cm-1 1.0 
-
-| B    ÃâŠ    1.0 
+A               |cm^-1|   1.0
+B               |Ang|     1.0
 ==============  ========  =============
 
@@ -4486,8 +4365,8 @@
 Â Â Â  Same as the ReflectivityModel except that the it is more
 customizable. More interfacial functions are supplied. The number of
-points (npts\_inter) for each interface can be choosen. Â Â Â  The constant
+points (npts_inter) for each interface can be choosen. Â Â Â  The constant
 (A below but 'nu' as a parameter name of the model) for exp, erf, or
 power-law is an input. The SLD at the interface between layers,
-*rinter\_i*, is calculated with a function chosen by a user, where the
+*rinter_i*, is calculated with a function chosen by a user, where the
 functions are:
 
@@ -4537,19 +4416,14 @@
 **Default input parameter values**
 
-==============  ========  =============
-Parameter name  Units     Default value
-==============  ========  =============
-| Background              | cm-1 0.01
-
-| Guinier scale           | cm-1 1.7 
-
-| Lorentzian scale        | cm-1 3.5 
-
-| Radius of gyration      | ÃâŠ    104 
-
-| Fractal exponent        | Â     2   
-
-| Correlation length      | ÃâŠ    16  
-==============  ========  =============
+==================  ========  =============
+Parameter name      Units     Default value
+==================  ========  =============
+Background          |cm^-1|   0.01
+Guinier scale       |cm^-1|   1.7
+Lorentzian scale    |cm^-1|   3.5
+Radius of gyration  |Ang|     104
+Fractal exponent    None Â     2
+Correlation length  |Ang|     16
+==================  ========  =============
 
 .. image:: img/image235.GIF