Index: docs/sphinx-docs/build_sphinx.py
===================================================================
--- docs/sphinx-docs/build_sphinx.py	(revision 9bf64f65441fe276eb820729b6f98aa17921310c)
+++ docs/sphinx-docs/build_sphinx.py	(revision 2fb09c45b38fabcf2370ba6a7b104a494ed35de3)
@@ -27,4 +27,5 @@
 SASVIEW_BUILD = os.path.abspath(os.path.join(CURRENT_SCRIPT_DIR, "..", "..", "build", "lib"+platform))
 SASVIEW_DOCS = os.path.join(SASVIEW_BUILD, "doc")
+SASVIEW_TEST = os.path.join(SASVIEW_SRC, "..", "sasview", "test", "media")
 
 SPHINX_BUILD = os.path.join(CURRENT_SCRIPT_DIR, "build")
@@ -34,4 +35,5 @@
 SPHINX_SOURCE_MODELS = os.path.join(SPHINX_SOURCE, "user", "models")
 SPHINX_SOURCE_PERSPECTIVES = os.path.join(SPHINX_SOURCE, "user", "perspectives")
+SPHINX_SOURCE_TEST = os.path.join(SPHINX_SOURCE, "test")
 
 BUMPS_DOCS = os.path.join(CURRENT_SCRIPT_DIR, "..", "..", "..",
@@ -55,4 +57,5 @@
     _remove_dir(SPHINX_SOURCE_MODELS)
     _remove_dir(SPHINX_SOURCE_PERSPECTIVES)
+    _remove_dir(SPHINX_SOURCE_TEST)
 
 def retrieve_user_docs():
@@ -87,4 +90,11 @@
 
             copy_tree(docs, dest_dir)
+            
+    # Now pickup testdata_help.rst
+#    print os.path.abspath(SASVIEW_TEST)
+#    print os.path.abspath(SPHINX_SOURCE_TEST)
+    if os.path.exists(SASVIEW_TEST):
+       print "Found docs folder at ", SASVIEW_TEST
+       shutil.copytree(SASVIEW_TEST, SPHINX_SOURCE_TEST)       
 
 def retrieve_bumps_docs():
Index: docs/sphinx-docs/source/conf.py
===================================================================
--- docs/sphinx-docs/source/conf.py	(revision eddf6af5bcc4640826d67df071f3e5da5dd092a8)
+++ docs/sphinx-docs/source/conf.py	(revision eddf6af5bcc4640826d67df071f3e5da5dd092a8)
@@ -53,5 +53,5 @@
 # General information about the project.
 project = u'SasView'
-copyright = u'2013, The SasView Project'
+copyright = u'2015, The SasView Project'
 
 # The version info for the project you're documenting, acts as replacement for
@@ -60,7 +60,7 @@
 #
 # The short X.Y version.
-version = '3.0.0'
+version = '3.1.0'
 # The full version, including alpha/beta/rc tags.
-release = '3.0.0'
+release = '3.1.0'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
Index: docs/sphinx-docs/source/index.rst
===================================================================
--- docs/sphinx-docs/source/index.rst	(revision 8042dbba6295d858218093297c3257680f194e0b)
+++ docs/sphinx-docs/source/index.rst	(revision 5a73356a9ee08ca3ab4f46b20ecd98c72b3a0842)
@@ -4,12 +4,10 @@
    contain the root `toctree` directive.
 
-SasView Documentation
-=====================
+SasView Documentation Index
+===========================
 
 .. toctree::
    :maxdepth: 1
 
-   Model Documentation <user/models/model_functions>
-   
    User Documentation <user/user>
 
Index: docs/sphinx-docs/source/test/testdata_help.rst
===================================================================
--- docs/sphinx-docs/source/test/testdata_help.rst	(revision a32aa3e14373298a264100bc214787fdafb3773f)
+++ docs/sphinx-docs/source/test/testdata_help.rst	(revision a32aa3e14373298a264100bc214787fdafb3773f)
@@ -0,0 +1,100 @@
+.. testdata_help.rst
+
+Test Data
+=========
+
+Test data sets are included as a convenience to our users. Look in the \test 
+sub-folder in your SasView installation folder.
+
+The data sets are organized based on their data structure; 1D data, 2D data, 
+SASVIEW saved states, and data in formats that are not yet implemented but 
+which are in the works for future versions.
+
+1D data sets have at least two columns of data with Intensity (assumed 
+absolute units) on the Y-axis and Q on the X-axis. 
+
+2D data sets are data sets that give the deduced intensity for each detector 
+pixel. Depending on the file extension, uncertainty and meta data may also be 
+available.
+
+Saved states are projects and analyses saved by the SasView program. A single 
+analysis file contains the data and parameters for a single fit (.fit), p(r) 
+inversion (.pr), or invariant calculation (.inv). A project file (.svs) contains 
+the results for every active analysis.
+
+Some of the available test data is described below.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+1D Test Data
+^^^^^^^^^^^^
+
+AOT_Microemulsion
+  - Aerosol-OT surfactant stabilised oil-in-water microemulsion data at three 
+    contrasts: core (oil core), drop (oil core + surfactant layer), and shell 
+    (surfactant layer).
+  - Suitable for testing simultaneous fitting.
+  
+hSDS_D2O
+  - h25-sodium dodecyl sulphate solutions at two concentrations: 0.5wt% (just 
+    above the cmc), 2wt% (well above the cmc), and 2wt% but with 0.2mM NaCl 
+    electrolyte.
+  - Suitable for testing charged S(Q) models.
+
+P123_D2O
+  - Lyotropic liquid crystalline solutions of non-ionic ABA block copolymer 
+    Pluronic P123 in water at three concentrations: 10wt%, 30wt%, and 40wt%.
+  - Suitable for testing paracrystal models.
+
+ISIS_Polymer_Blend_TK49
+  - Monodisperse (Mw/Mn~1.02) 49wt% d8-polystyrene : 51wt% h8-polystyrene 
+    polymer blend.
+  - Suitable for testing Poly_GaussCoil and RPA10 models.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+2D Test Data
+^^^^^^^^^^^^
+
+P123_D2O
+  - Lyotropic liquid crystalline solutions of non-ionic ABA block copolymer 
+    Pluronic P123 in water at three concentrations: 10wt%, 30wt%, and 40wt%.
+  - Suitable for testing paracrystal models.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+Saved State Test Data
+^^^^^^^^^^^^^^^^^^^^^
+
+_phi_weights.txt
+
+_radius_dist.txt
+
+_THETA_weights.txt
+
+fitstate.fitv
+
+newone.svs
+
+prstate.prv
+
+sld_file.sld
+
+test.inv
+
+test002.inv
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+Other Test Data
+^^^^^^^^^^^^^^^
+
+1000A_sphere_sm.xml
+
+diamond.pdb
+
+dna.pdb
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. note::  This help document was last changed by Steve King, 26Jun2015
Index: docs/sphinx-docs/source/user/user.rst
===================================================================
--- docs/sphinx-docs/source/user/user.rst	(revision 28812b8c479e622f069e76c620af8135f55e76f9)
+++ docs/sphinx-docs/source/user/user.rst	(revision 2e5ca089b3452d373071786c8aa58afa098b3734)
@@ -1,4 +1,6 @@
-User Documentation
-==================
+SasView User Documentation
+==========================
+
+.. note:: In Windows use [Alt]-[Cursor left] to return to the previous page
 
 .. toctree::
@@ -37,3 +39,3 @@
    Python Shell Tool <perspectives/calculator/python_shell_help>
    
-   Test Data <test/testdata.rst>
+   Test Data <../test/testdata_help.rst>